OGRE-Next: Ogre::Material Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::Material Class Referencefinal
Core » Materials

Class encapsulates rendering properties of an object. More...

`#include <OgreMaterial.h>`

Inheritance diagram for Ogre::Material:
[legend]

## Public Types
typedef FastArray< Real > | LodValueArray
| distance list used to specify LOD
typedef ConstVectorIterator< LodValueArray > | LodValueIterator
typedef VectorIterator< Techniques > | TechniqueIterator
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 , LF_MARKED_FOR_RELOAD = 8 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING , LOADSTATE_UNLOADED_MARKED_FOR_RELOAD }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| Material (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor - use resource manager's create method rather than this.
| ~Material () override
const LodValueArray * | _getLodValues () const
void | _notifyNeedsRecompile ()
| Tells the material that it needs recompilation.
bool | applyTextureAliases (const AliasTextureNamePairList &aliasList, const bool apply=true) const
| Applies texture names to Texture Unit State with matching texture name aliases.
MaterialPtr | clone (const String &newName, bool changeGroup=false, const String &newGroup=BLANKSTRING) const
| Creates a new copy of this material with the same settings but a new name.
void | compile (bool autoManageTextureUnits=true)
| 'Compiles' this Material.
void | copyDetailsTo (MaterialPtr &mat) const
| Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.
Technique * | createTechnique ()
| Creates a new Technique for this Material.
Technique * | getBestTechnique (unsigned short lodIndex=0, const Renderable *rend=0)
| Gets the best supported technique.
bool | getCompilationRequired () const
| Gets the compilation status of the material.
LodValueIterator | getLodValueIterator () const
| Gets an iterator over the list of values transformed by the LodStrategy at which each LOD comes into effect.
unsigned short | getNumLodLevels (const String &schemeName) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
unsigned short | getNumLodLevels (unsigned short schemeIndex) const
| Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.
unsigned short | getNumSupportedTechniques () const
| Retrieves the number of supported techniques.
unsigned short | getNumTechniques () const
| Retrieves the number of techniques.
bool | getReceiveShadows () const
| Returns whether or not objects using this material will receive shadows.
Technique * | getSupportedTechnique (unsigned short index)
| Gets the indexed supported technique.
TechniqueIterator | getSupportedTechniqueIterator ()
| Gets an iterator over all the Techniques which are supported by the current card.
Technique * | getTechnique (const String &name)
| searches for the named technique.
Technique * | getTechnique (unsigned short index)
| Gets the indexed technique.
TechniqueIterator | getTechniqueIterator ()
| Get an iterator over the Techniques in this Material.
bool | getTransparencyCastsShadows () const
| Returns whether or not objects using this material be classified as opaque to the shadow caster system.
const String & | getUnsupportedTechniquesExplanation () const
| Gets a string explaining why any techniques are not supported.
LodValueIterator | getUserLodValueIterator () const
| Gets an iterator over the user-defined list of values which are internally transfomed by the LodStrategy.
bool | isTransparent () const
| Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).
Material & | operator= (const Material &rhs)
| Assignment operator to allow easy copying between materials.
void | removeAllTechniques ()
| Removes all the techniques in this Material.
void | removeTechnique (unsigned short index)
| Removes the technique at the given index.
void | setAmbient (const ColourValue &ambient)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setAmbient (Real red, Real green, Real blue)
| Sets the ambient colour reflectance properties for every Pass in every Technique.
void | setBlendblock (const HlmsBlendblock &blendblock)
| Sets the blendbock to every pass.
void | setColourWriteEnabled (bool enabled)
| Sets whether or not colour buffer writing is enabled for each Pass.
void | setDiffuse (const ColourValue &diffuse)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setDiffuse (Real red, Real green, Real blue, Real alpha)
| Sets the diffuse colour reflectance properties of every Pass in every Technique.
void | setFog (bool overrideScene, FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=Real(0.001), Real linearStart=0.0, Real linearEnd=1.0)
| Sets the fogging mode applied to each pass.
void | setLodLevels (const LodValueArray &lodValues)
| Sets the distance at which level-of-detail (LOD) levels come into effect.
void | setMacroblock (const HlmsMacroblock &macroblock)
| Sets the macroblock for all passes.
void | setPointSize (Real ps)
| Sets the point size properties for every Pass in every Technique.
void | setReceiveShadows (bool enabled)
| Sets whether objects using this material will receive shadows.
void | setSamplerblock (const HlmsSamplerblock &samplerblock)
| Set samplerblock for every texture unit in every Technique and Pass.
void | setSelfIllumination (const ColourValue &selfIllum)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setSelfIllumination (Real red, Real green, Real blue)
| Sets the amount of self-illumination of every Pass in every Technique.
void | setShadingMode (ShadeOptions mode)
| Sets the type of light shading required.
void | setShininess (Real val)
| Sets the shininess properties of every Pass in every Technique.
void | setSpecular (const ColourValue &specular)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setSpecular (Real red, Real green, Real blue, Real alpha)
| Sets the specular colour reflectance properties of every Pass in every Technique.
void | setTransparencyCastsShadows (bool enabled)
| Sets whether objects using this material be classified as opaque to the shadow caster system.
void | touch () override
| 'Touches' the resource to indicate it has been used.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event.
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event.
virtual void | _fireUnloadingComplete ()
| Firing of unloading complete event.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual ResourceManager * | getCreator ()
| Gets the manager which created this resource.
virtual const String & | getGroup () const
| Gets the group which this resource is a member of.
virtual ResourceHandle | getHandle () const
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual const String & | getName () const
| Gets resource name.
virtual const String & | getOrigin () const
| Get the origin of this resource, e.g.
virtual size_t | getSize () const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual bool | isBackgroundLoaded () const
| Returns whether this Resource has been earmarked for background loading.
virtual bool | isLoaded () const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual bool | isManuallyLoaded () const
| Is this resource manually loaded?
virtual bool | isPrepared () const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isReloadable () const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
bool | markForReload ()
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?".
virtual void | setToLoaded ()
| Change the Resource loading state to loaded.
virtual void | unload ()
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Public Attributes inherited from Ogre::Resource
| OGRE_AUTO_MUTEX

## Detailed Description

Class encapsulates rendering properties of an object.

Remarks
  Ogre's material class encapsulates ALL aspects of the visual appearance, of an object. It also includes other flags which might not be traditionally thought of as material properties such as culling modes and depth buffer settings, but these affect the appearance of the rendered object and are convenient to attach to the material since it keeps all the settings in one place. This is different to Direct3D which treats a material as just the colour components (diffuse, specular) and not texture maps etc. An Ogre Material can be thought of as equivalent to a 'Shader'.

  A Material can be rendered in multiple different ways depending on the hardware available. You may configure a Material to use high-complexity fragment shaders, but these won't work on every card; therefore a Technique is an approach to creating the visual effect you are looking for. You are advised to create fallback techniques with lower hardware requirements if you decide to use advanced features. In addition, you also might want lower-detail techniques for distant geometry.

  Each technique can be made up of multiple passes. Programmable passes, however, cannot be split down automatically, so if the active graphics card cannot handle the technique which contains these passes, OGRE will try to find another technique which the card can do. If, at the end of the day, the card cannot handle any of the techniques which are listed for the material, the engine will render the geometry plain white, which should alert you to the problem.

Note: Using multiple passes hasn't been tested in Ogre-Next 2.x at all and may no longer work. It definitely needs at least RenderQueue::V1_LEGACY

  Ogre comes configured with a number of default settings for a newly created material. These can be changed if you wish by retrieving the default material settings through SceneManager::getDefaultMaterialSettings. Any changes you make to the Material returned from this method will apply to any materials created from this point onward.

## Member Typedef Documentation

## ◆ LodValueArray

typedef FastArray<Real> Ogre::Material::LodValueArray

distance list used to specify LOD

## ◆ LodValueIterator

typedef ConstVectorIterator<LodValueArray> Ogre::Material::LodValueIterator

## ◆ TechniqueIterator

typedef VectorIterator<Techniques> Ogre::Material::TechniqueIterator

## Constructor & Destructor Documentation

## ◆ Material()

Ogre::Material::Material | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Constructor - use resource manager's create method rather than this.

Referenced by operator=().

## ◆ ~Material()

Ogre::Material::~Material | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getLodValues()

const LodValueArray * Ogre::Material::_getLodValues | ( |  | ) | const
| inline

References _getLodValues().

Referenced by _getLodValues().

## ◆ _notifyNeedsRecompile()

void Ogre::Material::_notifyNeedsRecompile | ( |  | ) |

Tells the material that it needs recompilation.

References _notifyNeedsRecompile().

Referenced by _notifyNeedsRecompile().

## ◆ applyTextureAliases()

bool Ogre::Material::applyTextureAliases | ( | const AliasTextureNamePairList & | aliasList,
|  | const bool | apply = true ) const

Applies texture names to Texture Unit State with matching texture name aliases.

All techniques, passes, and Texture Unit States within the material are checked. If matching texture aliases are found then true is returned.

Parameters

  aliasList | is a map container of texture alias, texture name pairs
  apply | set true to apply the texture aliases else just test to see if texture alias matches are found.

Returns
  True if matching texture aliases were found in the material.

## ◆ clone()

MaterialPtr Ogre::Material::clone | ( | const String & | newName,
|  | bool | changeGroup = false,
|  | const String & | newGroup = BLANKSTRING ) const

Creates a new copy of this material with the same settings but a new name.

Parameters

  newName | The name for the cloned material
  changeGroup | If true, the resource group of the clone is changed
  newGroup | Only required if changeGroup is true; the new group to assign

References Ogre::BLANKSTRING.

## ◆ compile()

void Ogre::Material::compile | ( | bool | autoManageTextureUnits = true | ) |

'Compiles' this Material.

Remarks
  Compiling a material involves determining which Techniques are supported on the card on which OGRE is currently running, and for fixed-function Passes within those Techniques, splitting the passes down where they contain more TextureUnitState instances than the current card has texture units.

  This process is automatically done when the Material is loaded, but may be repeated if you make some procedural changes.

Parameters

  autoManageTextureUnits | If true, when a fixed function pass has too many TextureUnitState entries than the card has texture units, the Pass in question will be split into more than one Pass in order to emulate the Pass. If you set this to false and this situation arises, an Exception will be thrown.

Referenced by touch().

## ◆ copyDetailsTo()

void Ogre::Material::copyDetailsTo | ( | MaterialPtr & | mat | ) | const

Copies the details of this material into another, preserving the target's handle and name (unlike operator=) but copying everything else.

Parameters

  mat | Weak reference to material which will receive this material's settings.

## ◆ createTechnique()

Technique * Ogre::Material::createTechnique | ( |  | ) |

Creates a new Technique for this Material.

Remarks
  A Technique is a single way of rendering geometry in order to achieve the effect you are intending in a material. There are many reason why you would want more than one - the main one being to handle variable graphics card abilities; you might have one technique which is impressive but only runs on 4th-generation graphics cards, for example. In this case you will want to create at least one fallback Technique. OGRE will work out which Techniques a card can support and pick the best one.

  If multiple Techniques are available, the order in which they are created is important - the engine will consider lower-indexed Techniques to be preferable to higher-indexed Techniques, ie when asked for the 'best' technique it will return the first one in the technique list which is supported by the hardware.

## ◆ getBestTechnique()

Technique * Ogre::Material::getBestTechnique | ( | unsigned short | lodIndex = 0,
|  | const Renderable * | rend = 0 )

Gets the best supported technique.

Remarks
  This method returns the lowest-index supported Technique in this material (since lower-indexed Techniques are considered to be better than higher-indexed ones).

  The best supported technique is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns NULL, try calling Material::load.

Parameters

  lodIndex | The material LOD index to use
  rend | Optional parameter specifying the Renderable that is requesting this technique. Only used if no valid technique for the active material scheme is found, at which point it is passed to MaterialManager::Listener::handleSchemeNotFound as information.

## ◆ getCompilationRequired()

bool Ogre::Material::getCompilationRequired | ( |  | ) | const
| inline

Gets the compilation status of the material.

Returns
  True if the material needs recompilation.

## ◆ getLodValueIterator()

LodValueIterator Ogre::Material::getLodValueIterator | ( |  | ) | const

Gets an iterator over the list of values transformed by the LodStrategy at which each LOD comes into effect.

Remarks
  Note that the iterator returned from this method is not totally analogous to the one passed in by calling setLodLevels - the list includes a zero entry at the start (since the highest LOD starts at value 0). Also, the values returned are after being transformed by LodStrategy::transformUserValue.

## ◆ getNumLodLevels() [1/2]

unsigned short Ogre::Material::getNumLodLevels | ( | const String & | schemeName | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Remarks
  Note that this will not be up to date until the material has been compiled.

## ◆ getNumLodLevels() [2/2]

unsigned short Ogre::Material::getNumLodLevels | ( | unsigned short | schemeIndex | ) | const

Gets the number of levels-of-detail this material has in the given scheme, based on Technique::setLodIndex.

Remarks
  Note that this will not be up to date until the material has been compiled.

## ◆ getNumSupportedTechniques()

unsigned short Ogre::Material::getNumSupportedTechniques | ( |  | ) | const

Retrieves the number of supported techniques.

## ◆ getNumTechniques()

unsigned short Ogre::Material::getNumTechniques | ( |  | ) | const

Retrieves the number of techniques.

## ◆ getReceiveShadows()

bool Ogre::Material::getReceiveShadows | ( |  | ) | const
| inline

Returns whether or not objects using this material will receive shadows.

## ◆ getSupportedTechnique()

Technique * Ogre::Material::getSupportedTechnique | ( | unsigned short | index | ) |

Gets the indexed supported technique.

## ◆ getSupportedTechniqueIterator()

TechniqueIterator Ogre::Material::getSupportedTechniqueIterator | ( |  | ) |

Gets an iterator over all the Techniques which are supported by the current card.

Remarks
  The supported technique list is only available after this material has been compiled, which typically happens on loading the material. Therefore, if this method returns an empty list, try calling Material::load.

## ◆ getTechnique() [1/2]

Technique * Ogre::Material::getTechnique | ( | const String & | name | ) |

searches for the named technique.

Return 0 if technique with name is not found

## ◆ getTechnique() [2/2]

Technique * Ogre::Material::getTechnique | ( | unsigned short | index | ) |

Gets the indexed technique.

## ◆ getTechniqueIterator()

TechniqueIterator Ogre::Material::getTechniqueIterator | ( |  | ) |

Get an iterator over the Techniques in this Material.

## ◆ getTransparencyCastsShadows()

bool Ogre::Material::getTransparencyCastsShadows | ( |  | ) | const
| inline

Returns whether or not objects using this material be classified as opaque to the shadow caster system.

## ◆ getUnsupportedTechniquesExplanation()

const String & Ogre::Material::getUnsupportedTechniquesExplanation | ( |  | ) | const
| inline

Gets a string explaining why any techniques are not supported.

## ◆ getUserLodValueIterator()

LodValueIterator Ogre::Material::getUserLodValueIterator | ( |  | ) | const

Gets an iterator over the user-defined list of values which are internally transfomed by the LodStrategy.

Remarks
  Note that the iterator returned from this method is not totally analogous to the one passed in by calling setLodLevels - the list includes a zero entry at the start (since the highest LOD starts at value 0). Also, the values returned are after being transformed by LodStrategy::transformUserValue.

## ◆ isTransparent()

bool Ogre::Material::isTransparent | ( |  | ) | const

Determines if the material has any transparency with the rest of the scene (derived from whether any Techniques say they involve transparency).

## ◆ operator=()

Material & Ogre::Material::operator= | ( | const Material & | rhs | ) |

Assignment operator to allow easy copying between materials.

References Material().

## ◆ removeAllTechniques()

void Ogre::Material::removeAllTechniques | ( |  | ) |

Removes all the techniques in this Material.

## ◆ removeTechnique()

void Ogre::Material::removeTechnique | ( | unsigned short | index | ) |

Removes the technique at the given index.

## ◆ setAmbient() [1/2]

void Ogre::Material::setAmbient | ( | const ColourValue & | ambient | ) |

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setAmbient

## ◆ setAmbient() [2/2]

void Ogre::Material::setAmbient | ( | Real | red,
|  | Real | green,
|  | Real | blue )

Sets the ambient colour reflectance properties for every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setAmbient

## ◆ setBlendblock()

void Ogre::Material::setBlendblock | ( | const HlmsBlendblock & | blendblock | ) |

Sets the blendbock to every pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setBlendblock

References setBlendblock().

Referenced by setBlendblock().

## ◆ setColourWriteEnabled()

void Ogre::Material::setColourWriteEnabled | ( | bool | enabled | ) |

Sets whether or not colour buffer writing is enabled for each Pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setColourWriteEnabled

## ◆ setDiffuse() [1/2]

void Ogre::Material::setDiffuse | ( | const ColourValue & | diffuse | ) |

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDiffuse

## ◆ setDiffuse() [2/2]

void Ogre::Material::setDiffuse | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha )

Sets the diffuse colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setDiffuse

## ◆ setFog()

void Ogre::Material::setFog | ( | bool | overrideScene,
|  | FogMode | mode = FOG_NONE,
|  | const ColourValue & | colour = ColourValue::White,
|  | Real | expDensity = Real(0.001),
|  | Real | linearStart = 0.0,
|  | Real | linearEnd = 1.0 )

Sets the fogging mode applied to each pass.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setFog

References Ogre::FOG_NONE, and setFog().

Referenced by setFog().

## ◆ setLodLevels()

void Ogre::Material::setLodLevels | ( | const LodValueArray & | lodValues | ) |

Sets the distance at which level-of-detail (LOD) levels come into effect.

Remarks
  You should only use this if you have assigned LOD indexes to the Technique instances attached to this Material. If you have done so, you should call this method to determine the distance at which the lowe levels of detail kick in. The decision about what distance is actually used is a combination of this and the LOD bias applied to both the current Camera and the current Entity.

Parameters

  lodValues | A vector of Reals which indicate the LOD value at which to switch to lower details. They are listed in LOD index order, starting at index 1 (ie the first level down from the highest level 0, which automatically applies from a value of 0). These are 'user values', before being potentially transformed by the strategy, so for the distance strategy this is an unsquared distance for example.

References setLodLevels().

Referenced by setLodLevels().

## ◆ setMacroblock()

void Ogre::Material::setMacroblock | ( | const HlmsMacroblock & | macroblock | ) |

Sets the macroblock for all passes.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setMacroblock

## ◆ setPointSize()

void Ogre::Material::setPointSize | ( | Real | ps | ) |

Sets the point size properties for every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setPointSize

## ◆ setReceiveShadows()

void Ogre::Material::setReceiveShadows | ( | bool | enabled | ) |
| inline

Sets whether objects using this material will receive shadows.

Remarks
  This method allows a material to opt out of receiving shadows, if it would otherwise do so. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects. In any case, if you have a need to prevent shadows being received by material, this is the method you call to do it.

Note
  Transparent materials never receive shadows despite this setting. The default is to receive shadows.

## ◆ setSamplerblock()

void Ogre::Material::setSamplerblock | ( | const HlmsSamplerblock & | samplerblock | ) |

Set samplerblock for every texture unit in every Technique and Pass.

Note
  This property has been moved to the TextureUnitState class, which is accessible via the Technique and Pass. For simplicity, this method allows you to set these properties for every current TeextureUnitState, If you need more precision, retrieve the Technique, Pass and TextureUnitState instances and set the property there.

See also
  TextureUnitState::setSamplerblock

References setSamplerblock().

Referenced by setSamplerblock().

## ◆ setSelfIllumination() [1/2]

void Ogre::Material::setSelfIllumination | ( | const ColourValue & | selfIllum | ) |

Sets the amount of self-illumination of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSelfIllumination

## ◆ setSelfIllumination() [2/2]

void Ogre::Material::setSelfIllumination | ( | Real | red,
|  | Real | green,
|  | Real | blue )

Sets the amount of self-illumination of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSelfIllumination

## ◆ setShadingMode()

void Ogre::Material::setShadingMode | ( | ShadeOptions | mode | ) |

Sets the type of light shading required.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setShadingMode

## ◆ setShininess()

void Ogre::Material::setShininess | ( | Real | val | ) |

Sets the shininess properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setShininess

## ◆ setSpecular() [1/2]

void Ogre::Material::setSpecular | ( | const ColourValue & | specular | ) |

Sets the specular colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSpecular

## ◆ setSpecular() [2/2]

void Ogre::Material::setSpecular | ( | Real | red,
|  | Real | green,
|  | Real | blue,
|  | Real | alpha )

Sets the specular colour reflectance properties of every Pass in every Technique.

Note
  This property has been moved to the Pass class, which is accessible via the Technique. For simplicity, this method allows you to set these properties for every current Technique, and for every current Pass within those Techniques. If you need more precision, retrieve the Technique and Pass instances and set the property there.

See also
  Pass::setSpecular

## ◆ setTransparencyCastsShadows()

void Ogre::Material::setTransparencyCastsShadows | ( | bool | enabled | ) |
| inline

Sets whether objects using this material be classified as opaque to the shadow caster system.

Remarks
  This method allows a material to cast a shadow, even if it is transparent. By default, transparent materials neither cast nor receive shadows. Shadows will not be cast on any objects unless the scene is set up to support shadows (

See also
  SceneManager::setShadowTechnique), and not all techniques cast shadows on all objects.

## ◆ touch()

void Ogre::Material::touch | ( |  | ) |
| inlineoverridevirtual

'Touches' the resource to indicate it has been used.

Reimplemented from Ogre::Resource.

References compile(), and Ogre::Resource::touch().

The documentation for this class was generated from the following file:

- OgreMaterial.h